<?php

/**
 * Local config overrides.
 *
 * You can override the config.php settings here.
 * Don't do it unless you know what you're doing.
 * Use standard PHP syntax, see config.php for examples.
 *
 * @copyright 2002-2010 The SquirrelMail Project Team
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 * @version $Id: config_local.php 13893 2010-01-25 02:47:41Z pdontthink $
 * @package squirrelmail
 * @subpackage config
 */

$tmpdir = '/home/interworx/lib/squirrelmail/sessions';
if( is_dir( $tmpdir ) === false ) {
  mkdir( $tmpdir, 0711 );
  chown( $tmpdir, 'iworx-sqmail' );
}

ini_set('include_path', '/usr/local/interworx/lib/pear' . ':'. ini_get('include_path') );
ini_set( 'session.save_path', '/home/interworx/lib/squirrelmail/sessions' );

$imap_stream_options = array(
  'ssl' => array(
    'verify_peer' => false,
    'verify_peer_name' => false,
  )
);

error_reporting( E_ALL & ~E_COMPILE_WARNING & ~E_DEPRECATED & ~E_NOTICE & ~E_STRICT );
